#@+leo
#@+node:0::@file audio.py
#@+body
#@@language python
#@<< psstAudio declarations >>
#@+node:1::<< psstAudio declarations >>
#@+body
import time, os, Queue, thread
from pdb import set_trace as trace

import fastaudio
import speex

#import globals

sounds = {}

stream = None

#@-body
#@-node:1::<< psstAudio declarations >>


#@+others
#@+node:2::class audioFactory
#@+body
class audioFactory:
    """
    Class for audio I/O within PSST
    """
    def __init__(self, quality=4):
        try:
            # create an audio stream from portaudio
            self.stream = fastaudio.stream(11025, 1, 'int16', 3200, 5)
            print "audioFactory.__init__:Stream object created"
            self.stream.open()
            print "audioFactory.__init__:Stream opened"
            self.stream.start()
            print "audioFactory.__init__:Audio stream opened successfully"
        except:
            print "audioFactory.__init__:audio initialisation failed"
            raise

        # create a codec
        self.quality = quality
        self.prevAmplitude = 0
        print "audioFactory.__init__: creating speex codec object"
        self.codec = speex.new(quality)
        print "audioFactory.__init__: speech quality is %d" % quality

        self.sounds = {}               # Create cache of sound samples
        #self.qPlay = Queue.Queue(1024) # incoming audio data to play

        # launch play thread
        self.running = True
        #thread.start_new_thread(self.threadPlay, ())

    def setQuality(self, quality=4):
        self.quality = quality
        del self.codec
        self.codec = speex.new(quality)
        
    def readCompressed(self):
        """
        Read all available data from the
        sound device, and returns a raw string of the
        compressed speech data
        """
        #print "readCompressed: calling..."
        raw = self.stream.read()
        if not raw:
            #print "readCompressed: got nothing"
            self.prevAmplitude = 0
            return ''
        #print "readCompressed: got audio string of length %d" % len(raw)
        #ints = [i[0] for i in frames]

        self.prevAmplitude = self.stream.amplitude(raw, 0.01)
        raw1 = self.codec.encode(raw, True)
        #print "readCompressed: compressed to length %d" % len(raw1)
        return raw1

    def writeCompressed(self, raw):
        """
        Decompresses encoded speech data in string 'raw', and plays
        to audio device.
        Returns None
        """
        #decInts = self.codec.decode(raw)
        #decFrames = [(n,) for n in decInts]

        if not raw:
            return

        raw1 = self.codec.decode(raw, True)
        #return
        #raw = self.codec.decode(raw, True)
        if raw1:
            #print "writeCompressed: got compressed, length %d" % len(raw)
            try:
                #print "writeCompressed: expanded to length %d" % len(raw1)
                self.stream.write(raw1)
            except:
                print "audioFactory._writeCompressed: failed"

    def playsound(self, sndfile):
    
        print "psstAudio:playsound:path=", sndfile
    
        if not self.sounds.has_key(sndfile):
            raw = self.stream.readwav(sndfile)
            self.sounds[sndfile] = raw
        try:
            self.stream.write(self.sounds[sndfile])
        except:
            print "audioFactory._playsound: failed"

    def amplitude(self, sample, howmuch=0.1):
        return self.prevAmplitude

#@-body
#@-node:2::class audioFactory
#@-others


#@-body
#@-node:0::@file audio.py
#@-leo
